#!/bin/bash

###################################################################
# FIP-Box Builder V.1.4  - 17.05.2014 by RMarticke@cosimo.de
# 
# Changelog
# 22.07.2015
#  slacc privat 
# 16.10.2014
#    fipedit / prepare for sd-read-only
# 17.05.2014 
#    update_period changed to update_period_sec
# 09.04.2014 
#    dyndns checktime modified
# 06.03.2014 
#    libao not needed because of inadyn --disable audio
#    fipbox > /etc/hosts
# 04.02.2014
#    initial version
###################################################################


# Bei Defaultnamen ersetzen wir den Hostnamen mit fipbox
if grep raspberrypi /etc/hostname >> /dev/null ; then
 echo fipbox > /etc/hostname
 echo 127.0.1.2 fipbox >> /etc/hosts
fi

if grep ipv6 /etc/modules >> /dev/null ; then
 echo "IPv6 Modul bereits vorhanden."
else
 echo "IPv6 Modul nicht geladen. In /etc/modules eingetragen."
 echo ipv6 >> /etc/modules
fi

 if grep 172.16.254.1 /etc/rc.local ; then
  echo Notfall-IP schon im rc.local
 else
  grep -v "exit 0" /etc/rc.local | grep -v 172.16.254.1  > /tmp/rc.local
  echo Notfall-IP wird in rc.local geschrieben
cat << 'EOF' >> /tmp/rc.local
  ip a | grep BROADCAST | cut -d " " -f2 | head -n 1 | awk -F ":" '{print "ip addr add 172.16.254.1/30 dev "$1}' | sh
EOF
  cat /tmp/rc.local > /etc/rc.local
fi

if [ -e /usr/bin/6tunnel ]; then
echo "6tunnel bereit installiert"
else
echo "Installiere 6tunnel"
apt-get update
apt-get -y install 6tunnel
fi

if [ -e /usr/local/bin/inadyn-mt ]; then
echo "Dynamic DNS Updater bereits installiert"
else
echo "Dynamic DNS Updater wird heruntergeladen und kompiliert"
# not needed because of nosound 
#apt-get install -y libao-dev
wget http://sourceforge.net/projects/inadyn-mt/files/latest/download -O /tmp/inadyn.tgz
cd /tmp
tar xzf /tmp/inadyn.tgz
cd inadyn-mt*
./configure --disable-sound
make
make install
fi

##### Starten der Portmapper oder DynamicDNS Updater ueber rc.local checken
grep -v fipbox /etc/rc.local > /tmp/rc.local.tmp
grep -v "exit 0" /tmp/rc.local.tmp > /etc/rc.local
cat << 'EOF' >> /etc/rc.local
cat /etc/fipbox | grep "#AKTIV#DNS#" | grep -v ihr-name | awk -F "#" '{print "/usr/local/bin/inadyn-mt --background --dyndns_server_name members.feste-ip.net --username "$5" --update_period_sec 124 --ip_server_name v6.checkip.feste-ip.net / --password \""$6"\" --alias "$4" ip6"}' | grep -v ihr-name | sh
cat /etc/fipbox | grep "#AKTIV#PORTMAPPER#" | grep -v IPv4ZielIP | awk -F "#" '{print "/usr/bin/6tunnel -6 "$4" "$5" "$6}' | sh
cat /etc/fipbox | grep "#AKTIV#VPNMAPTCP" | awk -F "#" '{print "/sbin/iptables -A PREROUTING -t nat -i tun0 -p tcp --dport "$4" -j DNAT --to "$5":"$6}' | /bin/sh
cat /etc/fipbox | grep "#AKTIV#VPNMAPUDP" | awk -F "#" '{print "/sbin/iptables -A PREROUTING -t nat -i tun0 -p udp --dport "$4" -j DNAT --to "$5":"$6}' | /bin/sh
cat /etc/fipbox | grep "#AKTIV#VPNMAP" | awk -F "#" '{print "iptables -t nat -A POSTROUTING -o eth0 --dst "$5}' | /bin/sh

exit 0
EOF

if [ -e /bin/fipedit ]; then
echo "/bin/fipedit vorhanden"
else
echo "/bin/fipedit erstellen"
cat << 'EOF' > /bin/fipedit
sudo nano /etc/fipbox
sudo pkill 6tunnel
sudo pkill inadyn-mt
sudo sh /etc/rc.local
ps ax | grep 6tunnel | grep -v grep
EOF
chmod 755 /bin/fipedit
fi


if [ -e /etc/fipbox ]; then
echo "Konfigdatei /etc/fipbox vorhanden"
else
echo "Konfigdatei /etc/fipbox nicht vorhanden. Erstelle Basisconfig"
cat << 'EOF' > /etc/fipbox
################################################################################
# FIP-Box Einstellungen                                                        #
################################################################################
#                                                                              #
# Diese Datei steuert mit einfachen Konfigurationszeilen die FIP-Box           #
#                                                                              #
# Um einen Portmapper zu erstellen tragen Sie die Daten bitte wie folgt ein :  #
# #AKTIV#PORTMAPPER#IPv6Port#IPv4ZielIP#IPv4Port                               #
#                                                                              #
# Den Updateclient fuer das dynamische DNS koennen Sie wie folgt aktivieren :  #
# #AKTIV#DNS#ihr-name.feste-ip.net#HOSTID#Passwort                             #
#                                                                              #
# Wenn Sie mit den Einstellungen fertig sind druecken Sie [STRG][X] [Y] [ENTER]#
# um die Einstellungen zu speichern.                                           #
#                                                                              #
# Starten Sie Ihre Box dann mit sudo reboot neu.                               #
#                                                                              #
################################################################################

#INAKTIV#VPNMAPTCP#80#192.168.12.3#80
#INAKTIV#VPNMAPUDP#53#192.168.12.3#53

#INAKTIV#DNS#ihr-name.feste-ip.net#12345#Passwort
#AKTIV#PORTMAPPER#2222#192.168.3.30#22
#AKTIV#PORTMAPPER#80#192.168.3.100#80
EOF

cat << 'EOF' >> /etc/motd



    _|_|  _|            _|
  _|          _|_|_|    _|_|_|      _|_|    _|    _|
_|_|_|_|  _|  _|    _|  _|    _|  _|    _|    _|_|
  _|      _|  _|    _|  _|    _|  _|    _|  _|    _|
  _|      _|  _|_|_|    _|_|_|      _|_|    _|    _|
              _|
              _|                     by feste-ip.net



Einstellung bearbeiten  --> fipedit
Neustart                --> sudo reboot
IP-Adressen anzeigen    --> ifconfig

EOF

#echo "/var/log nach tmpfs"
#echo "tmpfs /var/log tmpfs nodev,nosuid,size=20M 0 0" >>/etc/fstab

echo "Anonymisierung IPv6 deaktivieren"
sed 's/slaac/#slaac/g' /etc/dhcpcd.conf > /tmp/dhcpcd.conf && mv /tmp/dhcpcd.conf /etc

echo "Neues Passwort fuer den Benutzer pi setzen."
passwd pi
fi
